"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Variant(ProtocolElement):
    """
    A `Variant` represents a change in DNA sequence relative to some
    reference. For example, a variant could represent a SNP or an
    insertion. Variants belong to a `VariantSet`. This is equivalent
    to a row in VCF.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
        "referenceBases",
        "referenceName",
        "variantSetId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import reports as reports_6_9_0

        return {
            "calls": reports_6_9_0.Call,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import reports as reports_6_9_0

        return {
            "org.gel.models.report.avro.Call": reports_6_9_0.Call,
            "org.gel.models.report.avro.Variant": reports_6_9_0.Variant,
        }

    __slots__ = [
        "id",
        "referenceBases",
        "referenceName",
        "variantSetId",
        "alternateBases",
        "calls",
        "created",
        "end",
        "info",
        "names",
        "start",
        "updated",
    ]

    def __init__(
        self,
        id,
        referenceBases,
        referenceName,
        variantSetId,
        alternateBases=list,
        calls=list,
        created=None,
        end=None,
        info=dict,
        names=list,
        start=None,
        updated=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_9_0.Variant model.

        :param id:
            The variant ID.
        :type id: str
        :param referenceBases:
            The reference bases for this variant. They start at the given start
            position.
        :type referenceBases: str
        :param referenceName:
            The reference on which this variant occurs. (e.g. `chr20` or `X`)
        :type referenceName: str
        :param variantSetId:
            The ID of the `VariantSet` this variant belongs to. This transitively
            defines the `ReferenceSet` against which the `Variant` is
            to be interpreted.
        :type variantSetId: str
        :param alternateBases:
            The bases that appear instead of the reference bases. Multiple
            alternate alleles are possible.
        :type alternateBases: list[str]
        :param calls:
            The variant calls for this particular variant. Each one represents the
            determination of genotype with respect to this variant.
            `Call`s in this array are implicitly associated with this
            `Variant`.
        :type calls: list[Call]
        :param created:
            The date this variant was created in milliseconds from the epoch.
        :type created: None | int
        :param end:
            The end position (exclusive), resulting in [start, end) closed-open
            interval. This is typically calculated by `start +
            referenceBases.length`. This is allowed to be null so that
            we can represent variants of unknown start location. This
            is the case in Dragens targeted callers where it is known
            that CNVs affect the gene but not where they start/end.
        :type end: None | int
        :param info:
            A map of additional variant information.
        :type info: dict[str, list[str]]
        :param names:
            Names for the variant, for example a RefSNP ID.
        :type names: list[str]
        :param start:
            The start position at which this variant occurs (0-based). This
            corresponds to the first base of the string of reference
            bases. Genomic positions are non-negative integers less
            than reference length. Variants spanning the join of
            circular genomes are represented as two variants one on
            each side of the join (position 0). This is allowed to be
            null so that we can represent variants of unknown start
            location. This is the case in Dragens targeted callers
            where it is known that CNVs affect the gene but not where
            they start/end.
        :type start: None | int
        :param updated:
            The time at which this variant was last updated in milliseconds from
            the epoch.
        :type updated: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.9.0"
